=== debian/changelog ===
anope (2.0.2-2) unstable; urgency=medium

  * Remove reference to obsolete services in package description
  * Enable compilation of extra modules (Closes: #783184)
  * Correct location of log file in shipped config file (Closes: #783185)
  * Emit warning when the init script 'reload' function is called and
    the daemon is not running (Closes: #783183)

 -- Dominic Hargreaves <dom@earth.li>  Wed, 27 May 2015 10:42:18 +0100

anope (2.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #661341)

 -- Dominic Hargreaves <dom@earth.li>  Mon, 13 Apr 2015 00:39:32 +0100
