=== debian/changelog ===
anope (2.0.3-1build2) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 12:13:10 +0000

anope (2.0.3-1build1) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:23:33 +0000

anope (2.0.3-1) unstable; urgency=medium

  * New upstream release (Closes: #813664)
  * Update default configuration files from upstream examples
  * Disable the webcpanel module because it results in Lintian errors
    about privacy breaches

 -- Dominic Hargreaves <dom@earth.li>  Mon, 15 Feb 2016 22:12:05 +0000
