=== debian/control ===
Source: anope
Section: net
Priority: optional
Maintainer: Dominic Hargreaves <dom@earth.li>
Build-Depends: debhelper (>= 9),
 cmake,
 libmysqlclient-dev,
 libldap2-dev,
 libpcre3-dev,
 libgnutls28-dev,
 libsqlite3-dev,
Standards-Version: 3.9.6
Homepage: http://www.anope.org/
Vcs-Git: git://anonscm.debian.org/users/dom/anope.git
Vcs-Browser: http://anonscm.debian.org/cgit/users/dom/anope.git

Package: anope
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 lsb-base (>= 3.2-14),
Recommends: default-mta | mail-tranport-agent
Description: IRC Services designed for flexibility and ease of use
 Anope offers various services to maintain your IRC network.
 .
 The following main services are included: NickServ, ChanServ, MemoServ,
 OperServ, BotServ, and HostServ.
 .
 The following IRC servers are supported:
 .
  * Bahamut 1.4.27 or later (including 1.8)
  * Charybdis 3.4 or later
  * Hybrid 8.1 or later
  * InspIRCd 1.2 or 2.0
  * ngIRCd 19.2 or later
  * Plexus 3 or later
  * Ratbox 2.0.6 or later
  * UnrealIRCd 3.2 or later
