=== debian/rules ===
--- 
+++ 
@@ -61,6 +61,11 @@
 	install -d -m 0700 -o irc -g irc debian/anope/var/lib/anope/db
 	install -d -m 0755 debian/anope/etc/anope
 	install -m 0640 -o root -g irc debian/conf/* debian/anope/etc/anope
+	# The external CDN references result in Lintian errors, and
+	# fixing this is non-trivial because it's an embedded web server.
+	# If you would like webcpanel to be enabled in Debian, please file
+	# a bug report.
+	rm -rf debian/anope/usr/lib/anope/modules/webcpanel.so debian/anope/usr/share/anope/data/modules/webcpanel
 
 override_dh_fixperms:
 	dh_fixperms -Xvar/log/anope -Xvar/lib/anope/db -Xetc/anope
