## anope 2.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -87,6 +87,9 @@
   if(GCC_VERSION LESS 4.2)
     message(FATAL_ERROR "Your compiler is too old to build Anope. Upgrade to GCC 4.2 or newer!")
   endif(GCC_VERSION LESS 4.2)
+  if(GCC_VERSION GREATER 6.0 OR GCC_VERSION EQUAL 6.0)
+    set(CXXFLAGS "${CXXFLAGS} -fno-delete-null-pointer-checks")
+  endif(GCC_VERSION GREATER 6.0 OR GCC_VERSION EQUAL 6.0)
 endif(CMAKE_COMPILER_IS_GNUCXX)
 
 # If we are using a GNU compiler (have to use CXX because it seems to fail on C), we will be able to determine it's default paths for libraries and includes
@@ -237,9 +240,3 @@
 # Use the following directories as includes
 # Note that it is important the binary include directory comes before the
 # source include directory so the precompiled headers work correctly.
-include_directories(${Anope_BINARY_DIR}/include ${Anope_SOURCE_DIR}/include ${Anope_BINARY_DIR}/language ${Anope_SOURCE_DIR}/modules/pseudoclients)
-
-# If using Windows, always add the _WIN32 define
-if(WIN32)
-  add_definitions(-D_WIN32)
-  # And include the windows specific folder for our anope_windows.h
