=== modules/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,10 @@
       if(IS_DIRECTORY "${MODULE_SRC}")
         build_modules("${MODULE_SRC}")
       else(IS_DIRECTORY "${MODULE_SRC}")
+        string(REGEX MATCH "\\.c$" ANOPE18MODULE ${MODULE_SRC})
+        if(ANOPE18MODULE)
+          message(FATAL_ERROR "Anope 1 modules are not compatible with Anope 2!\nOffending module: ${MODULE_SRC}")
+        endif(ANOPE18MODULE)
         string(REGEX MATCH "\\.cpp$" CPP ${MODULE_SRC})
         if(CPP)
           set_source_files_properties(${MODULE_SRC} PROPERTIES LANGUAGE CXX COMPILE_FLAGS "${CXXFLAGS}")
