=== debian/changelog ===
anope (2.0.4-2) unstable; urgency=high

  * Correct Recommends typo tranport -> transport to stop Exim taking
    over from already-installed MTAs (Closes: #864668)

 -- Dominic Hargreaves <dom@earth.li>  Tue, 13 Jun 2017 23:06:32 +0100

anope (2.0.4-1) unstable; urgency=medium

  * New upstream release
  * Switch to MySQL metapackage
  * Update Standards-Version (no changes)

 -- Dominic Hargreaves <dom@earth.li>  Wed, 23 Nov 2016 23:41:52 +0000

anope (2.0.3-3) unstable; urgency=medium

  * Create /var/lib/anope/db/backups to avoid anope shutting down
    when creating backups (Closes: #822371)

 -- Dominic Hargreaves <dom@earth.li>  Sun, 24 Apr 2016 18:03:48 +0100

anope (2.0.3-2) unstable; urgency=medium

  * Don't include build date/time in compiled binary, fixing build
    reproducibility (Closes: #820152)

 -- Dominic Hargreaves <dom@earth.li>  Sat, 23 Apr 2016 11:53:20 +0100
