=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
 Maintainer: Dominic Hargreaves <dom@earth.li>
 Build-Depends: debhelper (>= 9),
  cmake,
- libmysqlclient-dev,
+ default-libmysqlclient-dev,
  libldap2-dev,
  libpcre3-dev,
  libgnutls28-dev,
  libsqlite3-dev,
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.anope.org/
 Vcs-Git: git://anonscm.debian.org/users/dom/anope.git
 Vcs-Browser: http://anonscm.debian.org/cgit/users/dom/anope.git
@@ -19,7 +19,7 @@
 Depends: ${shlibs:Depends},
  ${misc:Depends},
  lsb-base (>= 3.2-14),
-Recommends: default-mta | mail-tranport-agent
+Recommends: default-mta | mail-transport-agent
 Description: IRC Services designed for flexibility and ease of use
  Anope offers various services to maintain your IRC network.
  .
