=== debian/rules ===
--- 
+++ 
@@ -51,6 +51,7 @@
 	-DLOCALE_DIR=share/anope/locale \
 	-DLOGS_DIR=../var/log/anope \
 	-DPROGRAM_NAME=anope \
+	-DREPRODUCIBLE_BUILD=1 \
 	-DDISABLE_TOOLS=1
 
 override_dh_auto_install:
@@ -59,6 +60,7 @@
 	chmod 0750 debian/anope/var/log/anope
 	install -d -m 0755 debian/anope/var/lib/anope
 	install -d -m 0700 -o irc -g irc debian/anope/var/lib/anope/db
+	install -d -m 0700 -o irc -g irc debian/anope/var/lib/anope/db/backups
 	install -d -m 0755 debian/anope/etc/anope
 	install -m 0640 -o root -g irc debian/conf/* debian/anope/etc/anope
 	# The external CDN references result in Lintian errors, and
